#ifndef vbuf_h
#define vbuf_h

#include <sys/uio.h>


typedef struct
{
  struct {
    /*long*/ long tot;	// total amount of data
    int seg;		// seg index
    int pos;		// pos within seg
  } fill, drain;

  int nseg;		// number of seg headers
  int useg;		// number of used seg headers (from beginning of seg)
  struct iovec* seg;

} Vbuf;



void vb_clear(Vbuf *b);


#define VBempty(b) ((b).fill.tot == (b).drain.tot)
#define VBcontents(b) ((b).fill.tot - (b).drain.tot)

void vb_dump (Vbuf* b);
void vb_dump_layout(Vbuf *b);



// read (fill) into buffer from file

int vb_read (Vbuf* b, int fd, int len);



// write (drain) from buffer to file

int vb_write (Vbuf* b, int fd, int len);


#endif
